<?php
require_once(dirname(__FILE__)."/PHPlotConfiguration.php");

require_once(dirname(__FILE__)."/db/DBIterator.php");
require_once(dirname(__FILE__)."/db/CSVFileIterator.php");
require_once(dirname(__FILE__)."/db/DBRecord.php");
require_once(dirname(__FILE__)."/db/DBRecordArrayMapper.php");
require_once(dirname(__FILE__)."/db/DBReader.php");
require_once(dirname(__FILE__)."/db/DBWriter.php");

require_once(dirname(__FILE__)."/hits/HitRecord.php");
require_once(dirname(__FILE__)."/hits/HitsFacade.php");
require_once(dirname(__FILE__)."/hits/HitsGenerator.php");
require_once(dirname(__FILE__)."/hits/HitsReader.php");
require_once(dirname(__FILE__)."/hits/HitsWriter.php");
require_once(dirname(__FILE__)."/hits/HitsGraph.php");

require_once(dirname(__FILE__)."/../lib/UserAgentParser.php");
require_once(dirname(__FILE__)."/sw/SWRecord.php");
require_once(dirname(__FILE__)."/sw/SWFacade.php");
require_once(dirname(__FILE__)."/sw/SWGenerator.php");
require_once(dirname(__FILE__)."/sw/SWReader.php");
require_once(dirname(__FILE__)."/sw/SWWriter.php");
require_once(dirname(__FILE__)."/sw/SWGraph.php");

require_once(dirname(__FILE__)."/util/Uarsorter.php");

class DBConfiguration {
    //private $path  /*= CONTENT_DIR."fpstats/"*/; /*see constructor*/
    public static $firstRecordTimestamp = 1214870401;

    public static function getPath() {
        return self::getPathToContetDir()."fpstats/";
    }

    public static function getPathToContetDir()
    {
        return CONTENT_DIR;
    }

    public static function getPathToActualYearDir()
    {
        return DBConfiguration::getPath().date("y")."/";
    }

    public static function getPathToActualCSVFile() {
        return self::getPathToActualYearDir() . date("m") . ".csv";
    }

    public static function getPathToStatsFile() {
        return DBConfiguration::getPath()."summary.txt";
    }

    public static function getPathToSWStatsFile() {
        return DBConfiguration::getPath()."summarySW.txt";
    }

    public static function getFirstRecordTimestamp() {
        return DBConfiguration::$firstRecordTimestamp;
    }
}
?>
