<?php
require_once(dirname(__FILE__)."/../DBConfiguration.php");
/**
 * @author Mat <mat_sf@users.sourceforge.net>
 */
class DBWriter {
    public function record() {
        $dbRecord = $this->mapPostDataToRecord();
        $array = DBRecordArrayMapper::mapToArray($dbRecord);

        $result = self::createDirsIfNotExist();
        if ($result === false)
        {
            return false;
        }

        $filePointer = fopen(DBConfiguration::getPathToActualCSVFile(), "a");

        if (!flock($filePointer, LOCK_EX)) {
            return false;
        }

        fputcsv($filePointer, $array);

        flock($filePointer, LOCK_UN);

        fclose($filePointer);

        return true;
    }

    private function mapPostDataToRecord() {
        $dbRecord = new DBRecord();
        if (isset($_SERVER["REQUEST_URI"])) {
            $dbRecord->setRequestURI($_SERVER["REQUEST_URI"]);
        } else {
            $dbRecord->setRequestURI("");
        }
        if (isset($_SERVER["HTTP_REFERER"])) {
            $dbRecord->setHttpReferer($_SERVER["HTTP_REFERER"]);
        } else {
            $dbRecord->setHttpReferer("");
        }
        if (isset($_SERVER["HTTP_USER_AGENT"])) {
            $dbRecord->setUserAgent($_SERVER["HTTP_USER_AGENT"]);
        } else {
            $dbRecord->setUserAgent("");
        }
        if (isset($_SERVER["REMOTE_ADDR"])) {
            $dbRecord->setRemoteAddress($_SERVER["REMOTE_ADDR"]);
        } else {
            $dbRecord->setRemoteAddress("");
        }
        $dbRecord->setSessionID(session_id());
        $dbRecord->setTimestamp(time());

        return $dbRecord;
    }

    public static function createDirsIfNotExist()
    {
        $result = true;

        if (file_exists(DBConfiguration::getPathToActualCSVFile()))
        {
            return true;
        }

        if (!file_exists(DBConfiguration::getPathToContetDir()))
        {
            return false;
        }

        if (!file_exists(DBConfiguration::getPath()))
        {
            $result = mkdir(DBConfiguration::getPath());

            if ($result === false)
            {
                return false;
            }
        }

        if (!file_exists(DBConfiguration::getPathToActualYearDir()))
        {
            $result = mkdir(DBConfiguration::getPathToActualYearDir());

            if ($result === false)
            {
                return false;
            }
        }

        return true;
    }
}

?>
