<?php
class HitsFacade {
    function __construct() {
    }

    public function getLimited($from, $to) {
        $data = $this->prepare();
        if (!is_array($data))
        {
            return array();
        }
        
        $unsetThese = null;

        $fromTimestamp = strtotime($from);
        $toTimestamp = strtotime($to);

        foreach ($data as $key => $record) {
            if ($key < $fromTimestamp || $key > $toTimestamp) {
                $unsetThese[] = $key;
            }
        }

        if (is_array($unsetThese)) {
            foreach ($unsetThese as $toBeRemoved) {
                unset($data[$toBeRemoved]);
            }
        }

        return $data;
    }

    public function prepare() {
        $hitsReader = new HitsReader();
        $data = $hitsReader->load();

        if (!is_array($data)) {
            return $this->prepareAll();
        }
        
        $hitsGenerator = new HitsGenerator();
        $data = $hitsGenerator->generateNew($data);

        $hitsWriter = new HitsWriter();
        $hitsWriter->write($data);

        return $data;
    }

    public function prepareAll() {
        $hitsGenerator = new HitsGenerator();
        $data = $hitsGenerator->generateAll();

        $hitsWriter = new HitsWriter();
        $hitsWriter->write($data);

        return $data;
    }
}

?>
