<?php
class HitsGenerator {
    private $dbIterator;

    function __construct() {
    }

    public function generateNew($data) {
        if (!is_array($data)) {
            return false;
        }

        end($data);
        $lastRecordTimestamp = key($data);
        unset($data[$lastRecordTimestamp]);

        $fpStatsBaseClass = new FPStatsBaseClass();
        $this->dbIterator = $fpStatsBaseClass->loadByDatesIterator(date("d.m.Y",$lastRecordTimestamp),date("d.m.Y",time()));

        return $this->generate($data);
    }

    public function generateAll() {
        fs_delete(DBConfiguration::getPathToStatsFile());
        $fpStatsBaseClass = new FPStatsBaseClass();
        $this->dbIterator = $fpStatsBaseClass->loadByDatesIterator(date("d.m.Y",DBConfiguration::getFirstRecordTimestamp()),date("d.m.Y",time()));

        return $this->generate(null);
    }

    private function generate($data) {
        $hitRecord = null;
        $sessionArray = null;

        foreach ($this->dbIterator as $key => $record) {
            $recordDayTimestamp = strtotime(date("d.m.Y",$record->getTimestamp()));

            if (is_array($data) && array_key_exists($recordDayTimestamp,$data)) {
                $hitRecord = $data[$recordDayTimestamp];
            } else {
                $hitRecord = new HitRecord();
            }

            $hitRecord->setAllHits($hitRecord->getAllHits() + 1);

            if (!is_array($sessionArray) || !array_key_exists($record->getSessionID(),$sessionArray) || $sessionArray[$record->getSessionID()] != $recordDayTimestamp) {
                $sessionArray[$record->getSessionID()] = $recordDayTimestamp;

                if (stripos($record->getUserAgent(), "http://") !== false) {
                    $hitRecord->setCrawlers($hitRecord->getCrawlers() + 1);
                } else {
                    $hitRecord->setUniqueHits($hitRecord->getUniqueHits() + 1);
                }
            }

            $data[$recordDayTimestamp] = $hitRecord;
        }

        return $data;
    }
}
?>
