<?php
class SWGenerator {
    private $dbIterator;

    function __construct() {
    }

    public function generateNew($data) {
        if (!is_array($data)) {
            return false;
        }

        end($data);
        $lastRecordTimestamp = key($data);
        unset($data[$lastRecordTimestamp]);

        $fpStatsBaseClass = new FPStatsBaseClass();
        $this->dbIterator = $fpStatsBaseClass->loadByDatesIterator(date("d.m.Y",$lastRecordTimestamp),date("d.m.Y",time()));

        return $this->generate($data);
    }

    public function generateAll() {
        fs_delete(DBConfiguration::getPathToSWStatsFile());
        $fpStatsBaseClass = new FPStatsBaseClass();
        $this->dbIterator = $fpStatsBaseClass->loadByDatesIterator(date("d.m.Y",DBConfiguration::getFirstRecordTimestamp()),date("d.m.Y",time()));

        return $this->generate(null);
    }

    private function generate($data) {
        $sessionArray = null;
        $swRecord = null;

        foreach ($this->dbIterator as $key => $record) {
            $recordDayTimestamp = strtotime(date("d.m.Y",$record->getTimestamp()));
            if (!is_array($sessionArray) ||
                    !array_key_exists($record->getSessionID(),$sessionArray) ||
                    $sessionArray[$record->getSessionID()] != $recordDayTimestamp) {

                $sessionArray[$record->getSessionID()] = $recordDayTimestamp;

                //filter bots
                if (stripos($record->getUserAgent(), "http://") !== false ||
                        stripos($record->getUserAgent(), "Sage") !== false) {
                    continue;
                }

                $recordMonthTimestamp = strtotime(date("1.m.Y",$record->getTimestamp()));

                $browserArray = UserAgentParser::getBrowser($record->getUserAgent());
                $osArray = UserAgentParser::getOperatingSystem($record->getUserAgent());

                //BROWSER
                if (is_array($browserArray)) {
                    $name = $browserArray["name"] . " " . $browserArray["version"];

                    if (is_array($data) && array_key_exists($recordMonthTimestamp,$data)) {
                        $swRecord = $data[$recordMonthTimestamp];
                        $swBrowserArray = $swRecord->getBrowserArray();

                        if (is_array($swBrowserArray) && array_key_exists($name,$swBrowserArray)) {
                            $swBrowserArray[$name]++;
                        } else {
                            $swBrowserArray[$name] = 1;
                        }
                        $swRecord->setBrowserArray($swBrowserArray);
                    } else {
                        $swRecord = new SWRecord();
                        $swBrowserArray[$name] = 1;
                        $swRecord->setBrowserArray($swBrowserArray);
                    }


                    $data[$recordMonthTimestamp] = $swRecord;
                }

                if (is_array($osArray)) {
                    $name = $osArray["name"];

                    if (is_array($data) && array_key_exists($recordMonthTimestamp,$data)) {
                        $swRecord = $data[$recordMonthTimestamp];
                        $swOSArray = $swRecord->getOSArray();

                        if (is_array($swOSArray) && array_key_exists($name,$swOSArray)) {
                            $swOSArray[$name]++;
                        } else {
                            $swOSArray[$name] = 1;
                        }
                        $swRecord->setOSArray($swOSArray);
                    } else {
                        $swRecord = new SWRecord();
                        $swOSArray[$name] = 1;
                        $swRecord->setOSArray($swOSArray);
                    }


                    $data[$recordMonthTimestamp] = $swRecord;
                }

                $browserArray = null;
                $osArray = null;
            }
        }

        return $data;
    }

}
?>
